/*********************************************************************/

#include <stdlib.h>    /* ANSI C standard library */
#include <stdio.h>     /* ANSI C standard input/output library */
#include <stdarg.h>    /* ANSI C standard arguments library */
#include "vpi_user.h"  /* IEEE 1364 PLI VPI routine library  */

PLI_INT32 PLIbook_GetVectorCalltf(PLI_BYTE8 *user_data),
          PLIbook_GetVectorCompiletf(PLI_BYTE8 *user_data),
          PLIbook_GetVectorSizetf(PLI_BYTE8 *user_data);

/**********************************************************************
 * VPI Registration Data for $test_user_data_1;
 *********************************************************************/
void PLIbook_test_user_data_register()
{
  s_vpi_systf_data tf_data;
  char *id1 = malloc(sizeof(int)); /* allocate user_data storage */
  char *id2 = malloc(sizeof(int)); /* allocate user_data storage */
  *id1 = 1;
  *id2 = 2;

  tf_data.type        = vpiSysFunc;
  tf_data.sysfunctype = vpiSysFuncSized;
  tf_data.tfname      = "$get_vector_bin";
  tf_data.calltf      = PLIbook_GetVectorCalltf;
  tf_data.compiletf   = PLIbook_GetVectorCompiletf;
  tf_data.sizetf      = PLIbook_GetVectorSizetf;
  tf_data.user_data   = (PLI_BYTE8 *)id1;
  vpi_register_systf(&tf_data);

  tf_data.type        = vpiSysFunc;
  tf_data.sysfunctype = vpiSysFuncSized;
  tf_data.tfname      = "$get_vector_hex";
  tf_data.calltf      = PLIbook_GetVectorCalltf;
  tf_data.compiletf   = PLIbook_GetVectorCompiletf;
  tf_data.sizetf      = PLIbook_GetVectorSizetf;
  tf_data.user_data   = (PLI_BYTE8 *)id2;
  vpi_register_systf(&tf_data);
}

/**********************************************************************
 * sizetf routine
 *********************************************************************/
PLI_INT32 PLIbook_GetVectorSizetf(PLI_BYTE8 *user_data)
{
  vpi_printf("\nIn sizetf,\tuser_data = %d\n", *user_data);
  return(8);
}

/**********************************************************************
 * compiletf routine
 *********************************************************************/
PLI_INT32 PLIbook_GetVectorCompiletf(PLI_BYTE8 *user_data)
{
  vpi_printf("\nIn compiletf,\tuser_data = %d\n", *user_data);
  return(0);
}

/**********************************************************************
 * test calltf routine
 *********************************************************************/
PLI_INT32 PLIbook_GetVectorCalltf(PLI_BYTE8 *user_data)
{
  vpi_printf("\nIn calltf,\tuser_data = %d\n", *user_data);
  if (*user_data == 1) {
    vpi_printf("calltf was invoked by $get_vector_bin()\n");
    /* read test vectors as binary values */
  }
  else if (*user_data == 2) {
    vpi_printf("calltf was invoked by $get_vector_hex()\n");
    /* read test vectors as hex values */
  }
  return(0);
}/*********************************************************************/
