/**********************************************************************
 * $count_args_vpi example -- PLI application using VPI routines
 *
 * Tests the VPI PLIbook_count_args_vpi() application.
 *
 * Usage: initial $count_args_vpi(<any_number_and_type_of_arguments>);
 *
 * For the book, "The Verilog PLI Handbook" by Stuart Sutherland
 *  Copyright 1999 & 2001, Kluwer Academic Publishers, Norwell, MA, USA
 *   Contact: www.wkap.il
 *  Example copyright 1998, Sutherland HDL Inc, Portland, Oregon, USA
 *   Contact: www.sutherland-hdl.com
 *********************************************************************/

#include <stdlib.h>    /* ANSI C standard library */
#include <stdio.h>     /* ANSI C standard input/output library */
#include <stdarg.h>    /* ANSI C standard arguments library */
#include "vpi_user.h"  /* IEEE 1364 PLI VPI routine library  */

/* prototypes of the PLI application routines */
PLI_INT32 PLIbook_CountArgsTestCall(PLI_BYTE8 *user_data);

#include "count_args_vpi.c"   /* include the VPI application */
/* #include "get_arg_handle_vpi_efficient.c"   /* include VPI app. */

/**********************************************************************
 * VPI Registration Data
 *********************************************************************/
void PLIbook_CountArgsTest_register()
{
  s_vpi_systf_data tf_data;
  tf_data.type        = vpiSysTask;
  tf_data.sysfunctype = 0;
  tf_data.tfname      = "$count_args_vpi";
  tf_data.calltf      = PLIbook_CountArgsTestCall;
  tf_data.compiletf   = NULL;
  tf_data.sizetf      = NULL;
  tf_data.user_data   = NULL;
  vpi_register_systf(&tf_data);
}
/**********************************************************************/

/**********************************************************************
 * calltf routine to exercise various utility functions.
 *********************************************************************/
PLI_INT32 PLIbook_CountArgsTestCall(PLI_BYTE8 *user_data)
{
  int num_args;

  vpi_printf("\n  Testing PLIbook_numargs_vpi()...\n");
  num_args = PLIbook_count_args_vpi();
  vpi_printf("  Number of args found = %d:  EXPECTED 6\n", num_args);

  vpi_printf("\n*** All Tests Completed ***\n\n");
  return(0);
}
/*********************************************************************/
