/**********************************************************************
 * $get_arg_val_test example -- Verilog HDL test bench.
 *
 * Verilog test bench to test the VPI get arg value applications.
 *
 * For the book, "The Verilog PLI Handbook" by Stuart Sutherland
 *  Copyright 1999 & 2001, Kluwer Academic Publishers, Norwell, MA, USA
 *   Contact: www.wkap.il
 *  Example copyright 1998, Sutherland HDL Inc, Portland, Oregon, USA
 *   Contact: www.sutherland-hdl.com
 *********************************************************************/
`timescale 1ns / 1ns
module test;
  reg  a, b, ci;
  wire sum, co;
  real r1;

  addbit i1 (a, b, ci, sum, co);

  initial
    begin
      a = 0; b = 1; ci = 1;
      r1 = 0.5;
      #10 $get_arg_val_test(b, r1, "Hello world", i1 );
      #10 $finish;
    end

 endmodule

/*** A gate level 1 bit adder model ***/
`timescale 1ns / 1ns
module addbit (a, b, ci, sum, co);
  input  a, b, ci;
  output sum, co;

  wire  a, b, ci, sum, co,
        n1, n2, n3;

  xor    (n1, a, b);
  xor #2 (sum, n1, ci);
  and    (n2, a, b);
  and    (n3, n1, ci);
  or  #2 (co, n2, n3);

endmodule
/**********************************************************************/
