/**********************************************************************
 * Example veriusertfs table that is used by many Verilog simulators
 * to register PLI applications that use the TF and ACC libraries of
 * the IEEE 1364 PLI.
 *
 * For the book, "The Verilog PLI Handbook" by Stuart Sutherland
 *  Copyright 1999 & 2001, Kluwer Academic Publishers, Norwell, MA, USA
 *   Contact: www.wkap.il
 *  Example copyright 1998, Sutherland HDL Inc, Portland, Oregon, USA
 *   Contact: www.sutherland-hdl.com
 *********************************************************************/

/* prototypes of the PLI application routines */
extern int PLIbook_pow_sizetf(int user_data, int reason);
extern int PLIbook_pow_checktf(int user_data, int reason);
extern int PLIbook_pow_calltf(int user_data, int reason);
extern int PLIbook_pow_misctf(int user_data, int reason, int pvc);
/* the veriusertfs table */
s_tfcell veriusertfs[] =
{
  {userfunction,             /* type of PLI routine */
    0,                       /* user_data value */
    PLIbook_pow_checktf,     /* checktf routine */
    PLIbook_pow_sizetf,      /* sizetf routine */
    PLIbook_pow_calltf,      /* calltf routine */
    PLIbook_pow_misctf,      /* misctf routine */
    "$pow",                  /* system task/function name */
    1                        /* forward reference = true */
  },
  {0} /*** final entry must be 0 ***/
};
