/**********************************************************************
 * $strgetp_test example -- Verilog HDL test bench.
 *
 * Verilog test bench to test the $strgetp_test PLI application.
 *
 * For the book, "The Verilog PLI Handbook" by Stuart Sutherland
 *  Copyright 1999 & 2001, Kluwer Academic Publishers, Norwell, MA, USA
 *   Contact: www.wkap.il
 *  Example copyright 1998, Sutherland HDL Inc, Portland, Oregon, USA
 *   Contact: www.sutherland-hdl.com
 *********************************************************************/
`timescale 1ns / 1ns
module test;
  reg               reg1;
  reg        [31:0] reg2;
  reg signed [32:0] reg3;
  integer           i1, i2;
  real              r1, r2;

  initial
    begin
      reg1 = 1'b0;
      reg2 = -32'd1;
      reg3 = -32'd2;
      i1   = 3;
      i2   = -4;
      r1   = 5.5;
      r2   = -6.6;

      #1
      $display("\nIn Verilog, reg1 is %d", reg1); $strgetp_test(reg1);
      $display("\nIn Verilog, reg2 is %d", reg2); $strgetp_test(reg2);
      $display("\nIn Verilog, reg3 is %d", reg3); $strgetp_test(reg3);
      $display("\nIn Verilog, i1   is %d", i1  ); $strgetp_test(i1);
      $display("\nIn Verilog, i2   is %d", i2  ); $strgetp_test(i2);
      $display("\nIn Verilog, r1   is %f", reg1); $strgetp_test(r1);
      $display("\nIn Verilog, r2   is %f", reg1); $strgetp_test(r2);

      $display("\nIn Verilog, 7 is %d", 7);       $strgetp_test(7);
      $display("\nIn Verilog, -8 is %d", -8);     $strgetp_test(-8);
      $display("\nIn Verilog, 9.9 is %f", 9.9);   $strgetp_test(9.9);
      $display("\nIn Verilog, -10.1 is %f", -10.1); $strgetp_test(-10.1);

      #1 $finish;
    end

endmodule

/**********************************************************************/

