/**********************************************************************
 * Example file to register PLI applications with the Model Technology
 * ModelSim simulator.
 *
 * For the book, "The Verilog PLI Handbook".
 *********************************************************************/

#include "veriuser.h"

typedef int (*p_tffn)();

typedef struct t_tfcell
{
    short type;      /* USERTASK, USERFUNCTION, or USERREALFUNCTION  */
    short data;      /* passed as data argument of callback function */
	p_tffn checktf;  /* argument checking callback function          */
	p_tffn sizetf;   /* function return size callback function       */
	p_tffn calltf;   /* task or function call callback function      */
	p_tffn misctf;   /* miscellaneous reason callback function       */
    char *tfname;    /* name of system task or function              */

	/* The following fields are ignored by ModelSim Verilog */
    int forwref;
    char *tfveritool;
    char *tferrmessage;
    int hash;
    struct t_tfcell *left_p;
    struct t_tfcell *right_p;
    char *namecell_p;
    int warning_printed;
} s_tfcell, *p_tfcell;
/* values for 'type' field in tfcell structure */
#define usertask 1
#define USERTASK 1
#define userfunction 2
#define USERFUNCTION 2
#define userrealfunction 3
#define USERREALFUNCTION 3


#include "veriusertfs_table.h"


void init_usertfs()
{
  p_tfcell usertf;

  for (usertf = veriusertfs; usertf; usertf++) {
    if (usertf->type == 0)
      return;
    mti_RegisterUserTF(usertf);
  }
}
